unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Common, StdCtrls, ExtCtrls, FIGlet, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    btnQuitter: TButton;
    lstFonts: TListBox;
    Label1: TLabel;
    Panel5: TPanel;
    Label2: TLabel;
    Label3: TLabel;
    memTexte: TMemo;
    memResultat: TMemo;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    btnCopy: TButton;
    Label4: TLabel;
    Panel6: TPanel;
    Label5: TLabel;
    Splitter3: TSplitter;
    memInfosFont: TMemo;
    Panel7: TPanel;
    lblFontSize: TLabel;
    trkFontSize: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure btnQuitterClick(Sender: TObject);
    procedure memTexteChange(Sender: TObject);
    procedure lstFontsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure GetResultat;
    procedure btnCopyClick(Sender: TObject);
    procedure trkFontSizeChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

var
  MyFont: TFIGlet;

{$R *.dfm}

//----------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
  Liste: TStringList;
  i: integer;
  Nom: string;
  DefaultFound: boolean;
begin

  MyFont := TFIGlet.Create;

  // couleur et divers init
  memResultat.Color := RGBToColor(220, 220, 255);
  memResultat.Text  := '';
  memTexte.Color := RGBToColor(255, 255, 220);
  memTexte.Text  := 'Mettez votre'+CRLF+'texte ici !';   
  memInfosFont.Color := RGBToColor(255, 220, 220);
  memInfosFont.Text  := '';
  memInfosFont.Font.Color  := RGBToColor(100, 100, 100);
  trkFontSize.Position := 7;
  lstFonts.Color := RGBToColor(220, 255, 220);

  // liste des fonts
  lstFonts.Clear;
  DefaultFound := False;
  Liste := TStringList.Create;
  SearchFiles('.', 'flf', True, Liste);
  for i := 0 to Liste.Count - 1 do begin
    Nom := BaseName(Liste[i], '.flf');
    lstFonts.AddItem(Nom, nil);
    if Nom = 'standard' then begin
      lstFonts.Selected[i] := true;
      MyFont.FontFile := Liste[i];
      DefaultFound := True;
    end;
  end;
  if not DefaultFound then begin
    if lstFonts.Count>0 then begin
      lstFonts.Selected[0] := true;
      MyFont.FontFile := Liste[0];
    end;
  end;
  Liste.Free;

  GetResultat;
end;       
//----------------------------------------------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  MyFont.Free;
end;
//----------------------------------------------------------
procedure TForm1.btnCopyClick(Sender: TObject);
begin
  memResultat.SelectAll;
  memResultat.CopyToClipboard;
  memResultat.SelLength := 0;
end;
//----------------------------------------------------------
procedure TForm1.btnQuitterClick(Sender: TObject);
begin
  Self.Close;
end;
//----------------------------------------------------------
procedure TForm1.lstFontsClick(Sender: TObject);
begin
  MyFont.FontFile := 'fonts\'+lstFonts.Items[lstFonts.ItemIndex]+'.flf';
  GetResultat;
end;
//----------------------------------------------------------
procedure TForm1.memTexteChange(Sender: TObject);
begin
  GetResultat;
end;
//----------------------------------------------------------
procedure TForm1.trkFontSizeChange(Sender: TObject);
begin
  lblFontSize.Caption := IntToStr(trkFontSize.Position);
  memResultat.Font.Size := trkFontSize.Position;
end;
//----------------------------------------------------------
procedure TForm1.GetResultat;
begin
  memResultat.Text := MyFont.getString(memTexte.Text);
  memInfosFont.Text := MyFont.CommentText;
end;
//----------------------------------------------------------

end.
